﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.Json.Serialization;
using System.Threading.Tasks;

namespace Optiroute.DataLoader.Google
{
    /// <summary>
    /// Strukura json pro výsledek nalezení adresy přes API
    /// </summary>
    public class GeocodingnResults
    {
        public List<GeocodingResultItem> Results { get; set; } = new List<GeocodingResultItem>();
    }
    public class GeocodingResultItem
    {

        [JsonProperty("formatted_address")]
        public string FullAddress { get; set; }
        [JsonProperty("place_id")]
        public string PlaceId { get; set; }
    }
    /// <summary>
    /// Struktura json pro výsledek vápočtu vzdálenosti tras
    /// </summary>
    public class DistancematrixResults
    {
        public List<RowItem> Rows { get; set; }
        [JsonProperty("destination_addresses")]
        public List<string> DestinationAddresses { get; set; }
        [JsonProperty("origin_addresses")]
        public List<string> OriginAddresses { get; set; }
    }

    public class RowItem
    {
        public List<DistancematrixResultsItem> Elements { get; set; } = new List<DistancematrixResultsItem>();
    }

    public class DistancematrixResultsItem
    {
        /// <summary>
        /// Distance je vzdálenost trasy v metrech , obsahuje int počet metrů a text s počtem km
        /// </summary>
        public DataItem Distance { get; set; } 
        /// <summary>
        /// Durattion je vzdálenost trasy ve vteřinách, obsahuje int počet sekund a text s doubou trvání v hodinách a minutách
        /// </summary>
        public DataItem Duration { get; set; }
    }

    public class DataItem
    {
        public int Value { get; set; }
        public string Text { get; set; }
    }
}
