﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Threading.Tasks;
using System.Linq;
using Newtonsoft.Json;
using System.IO;
using Optiroute.Db.Model;

namespace Optiroute.Db
{
    public class DbContext
    {
        public List<Place> Places { get; set; } = new List<Place>();
        public List<Route> Routes { get; set; } = new List<Route>();

        public async Task SaveToFile(string fileName)
        {
            await File.WriteAllTextAsync(fileName, JsonConvert.SerializeObject(this, Formatting.Indented));
        }
        public static async Task<DbContext> LoadFromFile(string fileName)
        {
            var loadedFile = await File.ReadAllTextAsync(fileName);
            return JsonConvert.DeserializeObject<DbContext>(loadedFile);
        }

        public static DbContext LoadFromFileSync(string fileName)
        {
            var loadedFile = File.ReadAllText(fileName);
            return JsonConvert.DeserializeObject<DbContext>(loadedFile);
        }
    }
}
