﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Diagnostics;
namespace Optiroute.TSPAlgorithm
{
    public class TSPAlgorithmRandom : TSPAlgorithmCompute
    {
        public override string Name => "Náhodná cesta";
        public override string ShortName => "Random";

        public override RouteTSPResult ComputeTSPRoute(MatrixRoute matrixRoute)
        {
            //stopwatch slouží pro měření času výpočtu
            Stopwatch stopwatch = new Stopwatch();
            stopwatch.Start();
            int lentght = 0;
            //Vytvoří list placeID bez výchozí a končné poboky (pokud tam je)
            List<int> shufleIds = matrixRoute.placeIDs.Where(d => !(d == matrixRoute.DefaultPlaceID || d == matrixRoute.EndPlaceID)).ToList();
            //Náhodně seřadí cestu / pořadí položek v poli
            Random rng = new Random();
            int[] indexRandomField = shufleIds.OrderBy(a => rng.Next()).ToArray();
            //vytvoří list newRandomRoute kam se přiřadí výchozí bod + náhodně seřazená cesta + případně konečná pobočka
            List<int> RandomRouteAddressIDs = new List<int>();
            RandomRouteAddressIDs.Add(matrixRoute.DefaultPlaceID);
            for (int i = 0; i < indexRandomField.Count(); i++)
            {
                RandomRouteAddressIDs.Add(indexRandomField[i]);
            }
            if (matrixRoute.EndPlaceID != null) RandomRouteAddressIDs.Add(matrixRoute.EndPlaceID.Value);
            else RandomRouteAddressIDs.Add(matrixRoute.DefaultPlaceID);

            //Vypočítá délku celkové cesy z matice délek
            for (int i = 0; i < RandomRouteAddressIDs.Count() - 1; i++)
            {
                int cityOne = matrixRoute.placeIDs.IndexOf(RandomRouteAddressIDs[i]);
                int cityTwo = matrixRoute.placeIDs.IndexOf(RandomRouteAddressIDs[i + 1]);
                lentght = lentght + matrixRoute.matrixRoute[cityOne, cityTwo];
            }
            stopwatch.Stop();
            return new RouteTSPResult()
            {
                AddressisRoute = RandomRouteAddressIDs,
                Length = lentght,
                TimeCalculation = stopwatch.ElapsedMilliseconds
            };       
        }
    }
}
