﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Optiroute.Web.Models.Home
{
    [Serializable]
    public class IndexViewModel
    {
        public List<AddressViewModel> Addresses { get; set; } = new List<AddressViewModel>();
        public List<TravelModeViewModel> TravelModes { get; set; } = new List<TravelModeViewModel>();
        public List<RouteWeightViewModel> RouteWeights { get; set; } = new List<RouteWeightViewModel>();
        public string RouteWeightValue  { get; set; }
        public string TravelModeValue { get; set; }
    }
    [Serializable]
    public class AddressViewModel
    {
        public int Id { get; set; }
        public string NickName { get; set; }
        public bool Default { get; set; }
        public bool EndCity { get; set; }
        public bool Selected { get; set; }
    }
    [Serializable]
    public class TravelModeViewModel
    {
        public string Value { get; set; }
        public string Icon { get; set; } 
        public string TravelModeText { get; set; }
    }
    
    [Serializable]
    public class RouteWeightViewModel
    {
        public string Value { get; set; }
        public string RouteWeightText { get; set; }
        public string Icon { get; set; }
    }

}
