﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Optiroute.Db.Model;

namespace Optiroute.Web.Services
{
    public interface ICodeBookService
    {
        List<TravelMode> GetTravelModes();
        List<WeighMode> GetWeightModes();
    }
    public class CodeBookService : ICodeBookService
    {

        private List<TravelMode> _travelModeMaping = new List<TravelMode>()
        {
             new TravelMode(){Travel = Db.Model.TravelMode.Driving, TravelText= "Autem", TravelIcon = "fas fa-car"},
             new TravelMode(){Travel = Db.Model.TravelMode.Transit, TravelText= "Veřejnou dopravou", TravelIcon = "fas fa-bus"},
             new TravelMode(){Travel = Db.Model.TravelMode.Bicycling, TravelText= "Na kole", TravelIcon = "fas fa-bicycle"},
             new TravelMode(){Travel = Db.Model.TravelMode.Walking, TravelText= "Pěšky", TravelIcon = "fas fa-walking"}
        };

        private List<WeighMode> _routeWeightsMaping = new List<WeighMode>()
        { 
            new WeighMode(){Mode = WeightMode.Duration, WeightText = "Čas, potřebuji co nejrychlejší cestu", WeightIcon = "far fa-clock"},
            new WeighMode(){Mode = WeightMode.Distance, WeightText = "Kilomety, potřebuji co nejkratší cestu", WeightIcon = "fas fa-ruler"}
        };

        public List<TravelMode> GetTravelModes()
        {
            return _travelModeMaping;
        }

        public List<WeighMode> GetWeightModes()
        {
             return _routeWeightsMaping;
        }
    }

    public class TravelMode
    {
        public Db.Model.TravelMode Travel{ get; set; }
        public string TravelIcon { get; set; }
        public string TravelText { get; set; }
    }

    public class WeighMode
    {
        public Db.Model.WeightMode Mode { get; set; }
        public string WeightIcon { get; set; }
        public string WeightText { get; set; }
    }
}
