﻿using Optiroute.TSPAlgorithm;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Optiroute.Web.Services
{
    public interface ITSPComputeAlgorithmProviderService
    {
        List<TSPAlgorithmCompute> GetAllComputeAlgorithms();
    }
    public class TSPComputeAlgorithmProviderService : ITSPComputeAlgorithmProviderService
    {
        private readonly TSPAlgorithmCompute[] _supportedComputeAlgorithms;

        public TSPComputeAlgorithmProviderService(params Optiroute.TSPAlgorithm.TSPAlgorithmCompute[] supportedAlgorithms)
        {
            this._supportedComputeAlgorithms = supportedAlgorithms;
        }

        public List<TSPAlgorithm.TSPAlgorithmCompute> GetAllComputeAlgorithms()
        {
            return _supportedComputeAlgorithms.ToList();
        }
    }

    public interface ITSPOptimaliseAlgorithmProviderService
    {
        List<TSPAlgorithmOptimalisation> GetAllOptimalizationAlgorithms();
    }
    public class TSPOptiAlgorithmProviderService : ITSPOptimaliseAlgorithmProviderService
    {
        private readonly TSPAlgorithmOptimalisation[] _supportedOptimalizationAlgorithms;

        public TSPOptiAlgorithmProviderService(params TSPAlgorithmOptimalisation[] supportedAlgorithms)
        {
            this._supportedOptimalizationAlgorithms = supportedAlgorithms;
        }

        public List<TSPAlgorithmOptimalisation> GetAllOptimalizationAlgorithms()
        {
            return _supportedOptimalizationAlgorithms.ToList();
        }
    }
}
